#!/usr/bin/perl

  require '../../../guardiandigital-lib.pl';
  &ReadParse();

  $store    = $in{'store'};
  $cert_pem = "/home/httpd/$store/ssl/certificate.pem";
  $key_pem  = "/home/httpd/$store/ssl/key.pem";

  if ((-e $cert_pem) && (-e $key_pem)) {
    $SSL_STATUS  = "<FONT COLOR=GREEN>SSL is Enabled</FONT>\n";
    $SSL_STATUS .= "<INPUT TYPE=HIDDEN NAME=SSLStatus VALUE=1>\n";
  }
  else {
    $SSL_STATUS  = "<FONT COLOR=RED>SSL is Disabled</FONT>\n";
    $SSL_STATUS .= "<INPUT TYPE=HIDDEN NAME=SSLStatus VALUE=0>\n";
  }
  

  ### Get information for current certificiate.
  if (-e "/home/httpd/$store/ssl/certificate.pem") {

    $fingerprint_str = `openssl x509 -fingerprint -in $cert_pem`;
    ($cert_fingerprint) = ($fingerprint_str =~ m/Fingerprint\=(.*)/);

    $expiry_str  = `openssl x509 -dates -in $cert_pem`;
    ($cert_start) = ($expiry_str =~ m/notBefore\=(.*)/);
    ($cert_end)   = ($expiry_str =~ m/notAfter\=(.*)/);

    $issuer_str     = `openssl x509 -issuer -in $cert_pem`;
    ($issuer_o)     = ($issuer_str =~ m/\/O\=([^\/]+)\//);
    ($issuer_cn)    = ($issuer_str =~ m/\/CN\=([^\/]+)\//);
    ($issuer_email) = ($issuer_str =~ m/\/Email\=([^\-]+)/);

    $subject_str     = `openssl x509 -subject -in $cert_pem`;
    ($subject_o)     = ($subject_str =~ m/\/O\=([^\/]+)\//);
    ($subject_cn)    = ($subject_str =~ m/\/CN\=([^\/]+)\//);
    ($subject_email) = ($subject_str =~ m/\/Email\=([^\-]+)/);

  $CERTIFICATE_INFO  = "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=90%>";
  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody><B>Fingerprint</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$cert_fingerprint\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody><B>Valid</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$cert_start until $cert_end\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD VALIGN=TOP><DIV CLASS=nbody><B>Subject</TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$subject_cn\n";
  $CERTIFICATE_INFO .= "      <BR>$subject_o\n";
  $CERTIFICATE_INFO .= "      <BR>$subject_email\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  $CERTIFICATE_INFO .= "<TR>\n";
  $CERTIFICATE_INFO .= "  <TD VALIGN=TOP><DIV CLASS=nbody><B>Issuer</B></TD>\n";
  $CERTIFICATE_INFO .= "  <TD><DIV CLASS=nbody>$issuer_cn\n";
  $CERTIFICATE_INFO .= "      <BR>$issuer_o\n";
  $CERTIFICATE_INFO .= "      <BR>$issuer_email\n";
  $CERTIFICATE_INFO .= "</TR>\n";

  $CERTIFICATE_INFO .= "</TABLE>";


  }
  else {
    $CERTIFICATE_INFO = "<DIV CLASS=nbody>None</DIV>";
  }


  $sslinfo_help   = &hlink("[ Certificate Information ]", "SSLInfo");
  $sslstatus_help = &hlink("Current SSL Status", "SSLStatus");
  $sslcert_help   = &hlink("Current SSL Certificate", "SSLCert_current");

  $sslcert_help2  = &hlink("Upload SSL Certificate", "SSLCert");
  $sslkey_help2   = &hlink("Upload SSL Key", "SSLKey");

  ### Good ol' header.
  &header("Edit SSL Configuration", 0);

  print <<EOF01;
<FORM ACTION="save_ssl.cgi" ENCTYPE="multipart/form-data" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<INPUT TYPE=HIDDEN NAME=SERVERINDEX_443 VALUE=$SERVERINDEX_443>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit SSL Configuration</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can change your SSL settings for this store. <B>Uploading or
    generating a new certificate and key will overwrite the pair you currently
    have in place.

    <P><B>$sslinfo_help</B>

    <P><B>Clicking on "Update Store" will make your changes take effect.</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>SSL Configuration</B></DIV>
      </TD></TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD VALIGN=TOP><DIV CLASS=nbody><B>$sslstatus_help</TD>
        <TD VALIGN=TOP><DIV CLASS=nbody><B>$SSL_STATUS</TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD VALIGN=TOP><DIV CLASS=nbody><B>$sslcert_help</TD>
        <TD VALIGN=TOP><B>$CERTIFICATE_INFO</TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$sslcert_help2</TD>
        <TD><INPUT TYPE="file" NAME="certfile"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>$sslkey_help2</TD>
        <TD><INPUT TYPE="file" NAME="keyfile"></TD>
      </TR>

      </TABLE>
    </TD>
  </TR>
  <TR $cb>
    <TD COLSPAN=2>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD ALIGN=LEFT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="newpair" VALUE="Generate Certificate and Key">
        </DIV></TD>
        <TD ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="update_store" VALUE="Update Store">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF01

  ### Good ol' footer.
  &ryanFooter("/VHost/opensales/edit/");
  exit;
