#!/usr/bin/perl

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';

  &ReadParse();

  if (!$in{'update_store'}) {

    ### Good ol' header.
    &header("Edit Store", 0);

    print <<EOF01;
<FORM ACTION="edit_zip.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit Store Zip Code</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can change the Zip Code associated with this store.

    <P>Warning:  Changing this value will directly effect the store's shipping
    tables.  Be sure this value is correct or the shipping methods may not
    work properly.

    <P><B>Clicking on "Update Store" will make changes take effect.</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>AllCommerce Configuration</B></DIV>
      </TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Zip Code</TD>
        <TD WIDTH="70%"><INPUT TYPE=TEXT NAME=zipcode SIZE=5 VALUE="$zipcode" MAXLENGTH="5"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="update_store" VALUE="Update Store">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF01

    ### Good ol' footer.
    &ryanFooter("/VHost/opensales/edit/");
    exit;
  }

  ### ############################ #############################################
  ### We want to update the store. #############################################
  ### ############################ #############################################
  else {

    ### Get the setsite() routine to get configuration.  Store in $site.
    $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
    do $site_pm;
    $site = setsite();

    ### Setup local variables.
    my $site_dbiuser  =  $site->{'site_dbiuser'};
    my $site_dbipwd   =  $site->{'site_dbipwd'};
    my $STORE         =  $in{'store'};
    my $zipcode       =  $in{'zipcode'};

    ### Data checks.
    if (!$zipcode) { &PrintError("Please enter a zip code."); exit; }
    if ($zipcode !~ m/^[0-9][0-9][0-9][0-9][0-9]$/) {
      &PrintError("You entered an invalid zip code.  Please renter."); exit;
    }




    use DBI;
    $dbh = DBI->connect("DBI:mysql:database=$STORE;;host=localhost",
                        "$site_dbiuser", "$site_dbipwd");

    if ($dbh) {

      ### Let's move into our store's root directory.
      chdir "/home/httpd/$STORE/tools";

      ### Delete any old zip files.
      my @delfiles = glob "data/[0-9][0-9][0-9].csv";
      unlink @delfiles;

      ### Get the first three digits of our zip code for shipping tables.
      ($ups_code) = ($zipcode =~ m/^([0-9][0-9][0-9])[0-9][0-9]$/);

      $sth = $dbh->prepare("SELECT Filename FROM zipmap
                            WHERE Start <= $ups_code AND End >= $ups_code");
      $sth->execute(); ($filename) = $sth->fetchrow_array(); $sth->finish();


      ### Clear out the 'zonerate' and 'zonemap' tables.
      $dbh->do("DELETE FROM zonemap");
      $dbh->do("DELETE FROM zonerate");


      ### ...move the CSV for our zone into place...
      system "cp -a data/UPS_ZONES/$filename data/";

      ### ...and run 'import_shipping_tables.pl'.
      system "./import_shipping_tables.pl";

      ### Open the rates file and insert it into the database.
      open RATES, "data/UPS.rates.dbid";
        while (<RATES>) { $_ =~ s/\\g//; $rv = $dbh->do("$_"); }
      close RATES;

      ($zone) = ($filename =~ m/^([0-9]+)\.csv$/);

      ### Open the zones file and insert it into the database.
      open ZONES, "data/UPS.zones.$zone.dbid";
        while (<ZONES>) { $_ =~ s/\\g//; $rv = $dbh->do("$_"); }
      close ZONES;

      ### Disconnect from the DBMS.
      $dbh->disconnect();

      ### Go back to the index page.
      &redirect("/VHost/opensales/edit/");
    }
    else {
      &PrintError("There was an error connecting to the database.");
      exit -1;
    }
  }
