#!/usr/bin/perl

  require './apache-lib.pl';
  &ReadParse();


  $conf = &get_config();
  $vconf = $conf->[$in{'virt'}];

  if ($in{'delete'}) {
    ### Delete a virtual server.
    $vname = &virt_acl_name($vconf);

    if ($in{'db_name'} && ($in{'port'} == 80)) {
      ### Get the database name.
      ($db_name, $port) = split /\:/, $vname;
      $db_name =~ s/\./\_/g;

      ### Let's use the DBI since it's SO much more fun...
      use DBI;

      ### Get root's mysql password.
      open FILE, "/etc/webtool/SystemManager/config";
        while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $mysql_pass = $1; } }
      close FILE;
    
      ### Setup DBMS variables.
      $database = "mysql"; $host = "localhost"; $user = "root";

      ### Connect to the database.
      my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host", "$user",
                             "$mysql_pass");

      ### Drop the database.
      $sth = $dbh->prepare("DROP DATABASE $db_name");
      $sth->execute();
      $sth->finish();

      ### Get the site username and delete the database permissions.
      $sth = $dbh->prepare("SELECT User FROM mysql.db WHERE Db = '$db_name'");
      $sth->execute();
      $ref = $sth->fetchrow_hashref(); $db_uname = $ref->{'User'};
      $sth->finish();

      $sth = $dbh->prepare("DELETE FROM mysql.db WHERE Db = '$db_name'");
      $sth->execute();
      $sth->finish();

      ### Delete the user
      $sth = $dbh->prepare("DELETE FROM mysql.user WHERE User = '$db_uname'");
      $sth->execute();
      $sth->finish();

      ### Disconnect from the database.
      $dbh->disconnect();
    }


    ### Go head and delete the stuff from httpd.conf.
    $lref = &read_file_lines($vconf->{'file'});
    splice(@$lref, $vconf->{'line'}, $vconf->{'eline'} - $vconf->{'line'} + 1);
    &flush_file_lines();

    ###
    # Move DocumentRoot out of the way.
    #
    # Before we move the DocumentRoot we need to disable LIDS,
    # in case it is protecting the certificate and key.  We also
    # want to reload the config to get rid of the rule, if any.
    ###

    &lids_toggle("off");
      ($base_dir) = ($in{'root'} =~ m/^(.*)\/html$/);
      system "rm -rf $base_dir";
    &lids_reload();
    &lids_toggle("on");




    ### Delete webstat conf & cron files.
    $conf_file   = "/etc/webalizer/" . $in{'name'} . ".conf";
    $daily_file  = "/etc/cron.daily/webalizer_" . $in{'name'};
    $weekly_file = "/etc/cron.weekly/webalizer_" . $in{'name'};

    unlink $conf_file, $daily_file, $weekly_file;

    ### Wash up and go home for dinner.
    &redirect("");
  }

  else {

    ### If we want to set a new password then do it.
    if ($in{'db_pass'}) {
      ### Check integrity of password.
      if ($in{'db_pass'} =~ m/^[^\'\"\/]{1,16}$/) { $db_pass = $in{'db_pass'}; }
      else {
       $in{'db_pass'} =~ s/\"/\\\"/g;
       &PrintError("'$in{'db_pass'}' is not a database password.");
      }


      $vname = &virt_acl_name($vconf);
      $db_uname = $in{'db_uname'};

      ### Get the database name.
      ($db_name, $port) = split /\:/, $vname;
      $db_name =~ s/\./\_/g;

      ### Let's use the DBI since it's SO much more fun...
      use DBI;

      ### Get root's mysql password.
      open FILE, "/etc/webtool/SystemManager/config";
        while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $mysql_pass = $1; } }
      close FILE;

      ### Setup DBMS variables.
      $database = "mysql"; $host = "localhost"; $user = "root";

      ### Connect to the database.
      my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host", "$user",
                             "$mysql_pass");

      ### Update the password.
      $sth = $dbh->prepare("UPDATE mysql.user SET Password=PASSWORD('$db_pass') WHERE User = '$db_uname'");
      $sth->execute();
      $sth->finish();

      ### Reload the grant tables.
      $sth = $dbh->prepare("FLUSH PRIVILEGES");
      $sth->execute();
      $sth->finish();

      ### Disconnect from the database.
      $dbh->disconnect();
    }

    # Update virtual server and directives
    &error_setup($text{'vserv_err'});

    # Check address
    if ($in{'addr_def'}) {
      if ($httpd_modules{'core'} >= 1.2) { $addr = "_default_"; }
      else { $addr = "*"; }
    }
    elsif ($in{'addr'} !~ /\S/) { &error($text{'vserv_eaddr1'}); }
    elsif (!gethostbyname($in{'addr'}) && !&check_ipaddress($in{'addr'})) {
      &error(&text('vserv_eaddr2', $in{'addr'}));
    }
    else { $addr = $in{'addr'}; }


    ### The port is now a dropdown, so just set it to 80 or 443.
    $port = ":$in{'port'}";


    ### Check document root
    if (!$in{'root_def'}) {
      (-d $in{'root'}) || &error(&text('vserv_eroot', $in{'root'}));
      $root = $in{'root'};
    }


    ### Check server name
    if (!$in{'name_def'}) {
      $in{'name'} =~ /^\S+$/ || &error(&text('vserv_ename', $in{'name'}));
      $name = $in{'name'};
    }

### print "Content-type: text/html\n\n<PRE>\n\n";
### print "addr    = $addr\n";
### print "port    = $port\n";
### print "root    = $root\n";
### print "name    = $name\n";
### exit;


    ### Update <VirtualHost> directive
    $lref = &read_file_lines($vconf->{'file'});
    $lref->[$vconf->{'line'}] = "<VirtualHost $addr$port>";

    ### Update DocumentRoot and ServerName
    ### &save_directive("DocumentRoot", $root ? [ $root ] : [ ],
                    ### $vconf->{'members'}, $conf);
    &save_directive("ServerName", $name ? [ $name ] : [ ],
                    $vconf->{'members'}, $conf);

    ### write out file
    &flush_file_lines();

    &redirect("virt_index.cgi?virt=$in{'virt'}");
  }

